SilentInstall silent

; The name of the NSIS install program you're creating
Name "SVAR File Open Dialog"
SetPluginUnload  alwaysoff
!include "${NSISDIR}\Contrib\System\sysfunc.nsh"
!define VAR_0 0 ;$0
!define VAR_1 1 ;$1
!define VAR_2 2 ;$2
!define VAR_3 3 ;$3
!define VAR_4 4 ;$4
!define VAR_5 5 ;$5
!define VAR_6 6 ;$6
!define VAR_7 7 ;$7
!define VAR_8 8 ;$8
!define VAR_9 9 ;$9
!define VAR_R0 10 ;$R0
!define VAR_R1 11 ;$R1
!define VAR_R2 12 ;$R2
!define VAR_R3 13 ;$R3
!define VAR_R4 14 ;$R4
!define VAR_R5 15 ;$R5
!define VAR_R6 16 ;$R6
!define VAR_R7 17 ;$R7
!define VAR_R8 18 ;$R8
!define VAR_R9 19 ;$R9
!define VAR_CMDLINE 20 ;$CMDLINE
!define VAR_INSTDIR 21 ;$INSTDIR
!define VAR_OUTDIR 22 ;$OUTDIR
!define VAR_EXEDIR 23 ;$EXEDIR
!define VAR_LANGUAGE 24 ;$LANGUAGE

; The icon
Icon "fileopen.ico"

; The file that NSIS writes
OutFile "fileopen.exe"

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "fileopen.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "fileopen.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Displays open file dialog"

Section "Launch"
  Call GetParameters
  Pop $R8
  Push $1
  StrCpy $1 $R8
  ;
  ; check if command line is empty
  ;
  StrCmp $1 '' usage
  SetPluginUnload manual
  System::Free 0
  Call SplitCommand
  Pop $R2
  ;
  ; now we need to split the command-line at $R2
  ; into $1 the directory, $2 the file-filter, $4
  ; the file_index, and $3 the windowname
  ;
  Push $3
  Push $R0
  StrLen $R0 $1
  IntOp $R0 $R0 - $R2
  StrCpy $3 $1 $R0 $R2
  IntOp $R2 $R2 - 1
  StrCpy $1 $1 $R2 0
  ;
  ; we now have that $1 contains the default directory
  ; get $2 from $3
  ;
  Call SplitNext
  Pop $R2
  Push $2
  StrLen $R0 $3
  IntOp $R0 $R0 - $R2
  StrCpy $2 $3 $R0 $R2
  IntOp $R2 $R2 - 1
  StrCpy $3 $3 $R2 0
  StrCpy $R0 $3
  StrCpy $3 $2
  StrCpy $2 $R0
  ;
  ; get $4 from $3
  ;
  Call SplitNext
  Pop $R2
  Push $4
  StrLen $R0 $3
  IntOp $R0 $R0 - $R2
  StrCpy $4 $3 $R0 $R2
  IntOp $R2 $R2 - 1
  StrCpy $3 $3 $R2 0
  StrCpy $R0 $3
  StrCpy $3 $4
  StrCpy $4 $R0
  ;
  ; Split $3 into windowname
  ; and dialog header
  ;
  Call SplitNext
  Pop $R2
  Push $5
  StrLen $R0 $3
  IntOp $R0 $R0 - $R2
  StrCpy $5 $3 $R0 $R2
  IntOp $R2 $R2 - 1
  StrCpy $3 $3 $R2 0
  ;
  ; $5 now hold the dialog title and $3 the windowname
  ;
  ;
  ; now we need to remove any " characters from $1 and $3
  ;
  StrCpy $R0 $1 1 0
  StrCmp $R0 '"' fix1 check2
  fix1:
    StrLen $R0 $1
    IntOp $R0 $R0 - 2
    StrCpy $1 $1 $R0 1
  check2:
    StrCpy $R0 $2 1 0
    StrCmp $R0 '"' fix2 check3
  fix2:
    StrLen $R0 $2
    IntOp $R0 $R0 - 2
    StrCpy $2 $2 $R0 1
  check3:
    StrCpy $R0 $3 1 0
    StrCmp $R0 '"' fix3 check4
  fix3:
    StrLen $R0 $3
    IntOp $R0 $R0 - 2
    StrCpy $3 $3 $R0 1
  check4:
    StrCpy $R0 $4 1 0
    StrCmp $R0 '"' fix4 check5
  fix4:
    StrLen $R0 $4
    IntOp $R0 $R0 - 2
    StrCpy $4 $4 $R0 1
  check5:
    StrCpy $R0 $5 1 0
    StrCmp $R0 '"' fix5 start
  fix5:
    StrLen $R0 $5
    IntOp $R0 $R0 - 2
    StrCpy $5 $5 $R0 1
  start:
  ;
  ; check if last char in $1 is \
  ; if so, delete it
  ;
  StrLen $R0 $1
  IntOp $R0 $R0 - 1
  StrCpy $R2 $1 1 $R0
  StrCmp $R2 "\" 0 findwin
  StrCpy $1 $1 $R0 0
  ;
  findwin:
  
  ;
  ; try to find the window with title given by $3
  ; so that dialog opens in a position relative to
  ; that window
  ;
  FindWindow $3 "" "$3"
  StrCmp $3 0 getwindow runfolder
  getwindow:
    StrCpy $3 $HWNDPARENT
  ;
  runfolder:
;    MessageBox MB_OK "$3$\n$2$\n$4$\n$1$\n$5$\n"
;    MessageBox MB_OK "$1"
    ;
    ; version 2.1 and earlier of Dialogs
    ;
    Dialogs::Open $3 "$2" "$4" "$5" "$1" ${VAR_6}
    ;
    ; version 2.2 and later of Dialogs
    ;
;    Dialogs::Open "$2" "$4" "$5" "$1" ${VAR_6}
;    MessageBox MB_OK "$6"
;    MessageBox MB_OK "$6"
    StrCmp $6 "0" Cancel
    StrCmp $6 "" Cancel Ok
  Cancel:
     StrCpy $6 cancel
  Ok:
    Push $9
    FileOpen $9 '$EXEDIR\fileopen.txt' w ;Opens a Empty File an fills it
    FileWrite $9 "$6$\r$\n"
    FileClose $9 ;Closes the emtpy file
    GoTo stop
  ;
  usage:
    !insertmacro smMessageBox "i 0" "Usage:$\n$\n    fileopen dir custom_file_filter filter_index windowname dialog_title$\n$\nwhere DIR is the directory where the open file dialog should open,$\nCUSTOM_FILE_FILTER is the file_filter, FILTER_INDEX is the$\ndefault value among the items in the CUSTOM_FILE_FILTER,$\nWINDOWNAME is the text string in the window titlebar, and$\nDIALOG_TITLE is the text in the titlebar of the filo open dialog.$\nfileopen writes your selection to the file 'fileopen.txt' in$\n'$EXEDIR'. Please use quotation marks around$\nall input variables so that fileopen can easily separate these 5$\nvariables from one another.$\n" "SVAR File Open Dialog" ${MB_OK} "i 103"
  stop:
  Quit
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

Function SplitCommand
   Push $R0
   Push $R1
   Push $R2
   StrCpy $R0 $1 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $1 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $1 1 $R2
      StrCmp $R0 " " loop2
   Exch $R2
FunctionEnd

Function SplitNext
   Push $R0
   Push $R1
   Push $R2
   StrCpy $R0 $3 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $3 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $3 1 $R2
      StrCmp $R0 " " loop2
   Exch $R2
FunctionEnd


