SilentInstall silent

; The name of the NSIS install program you're creating
Name "SVAR Folder Browser"
SetPluginUnload  alwaysoff
!include "${NSISDIR}\Contrib\System\sysfunc.nsh"
!include "${NSISDIR}\Include\StrFunc.nsh"
${StrRep}
!define VAR_0 0 ;$0
!define VAR_1 1 ;$1
!define VAR_2 2 ;$2
!define VAR_3 3 ;$3
!define VAR_4 4 ;$4
!define VAR_5 5 ;$5
!define VAR_6 6 ;$6
!define VAR_7 7 ;$7
!define VAR_8 8 ;$8
!define VAR_9 9 ;$9
!define VAR_R0 10 ;$R0
!define VAR_R1 11 ;$R1
!define VAR_R2 12 ;$R2
!define VAR_R3 13 ;$R3
!define VAR_R4 14 ;$R4
!define VAR_R5 15 ;$R5
!define VAR_R6 16 ;$R6
!define VAR_R7 17 ;$R7
!define VAR_R8 18 ;$R8
!define VAR_R9 19 ;$R9
!define VAR_CMDLINE 20 ;$CMDLINE
!define VAR_INSTDIR 21 ;$INSTDIR
!define VAR_OUTDIR 22 ;$OUTDIR
!define VAR_EXEDIR 23 ;$EXEDIR
!define VAR_LANGUAGE 24 ;$LANGUAGE

; The icon
Icon "folder.ico"

; The file that NSIS writes
OutFile "folder.exe"

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "folder.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "folder.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Displays select folder dialog"

Section "Launch"
  Call GetParameters
  Pop $R8
  Push $1
  StrCpy $1 $R8
  ;
  ; check if command line is empty
  ;
  StrCmp $1 '' usage
  SetPluginUnload manual
  System::Free 0
  ${StrRep} $1 '$1' "'" '"'
  Call SplitCommand
  Pop $R2
  ;
  ; now we need to split the command-line at $R2
  ; into $1 the directory, and $3 the windowname
  ;
  Push $3
  Push $R0
  StrLen $R0 $1
  IntOp $R0 $R0 - $R2
  StrCpy $3 $1 $R0 $R2
  IntOp $R2 $R2 - 1
  StrCpy $1 $1 $R2 0
  ;
  ; now we need to remove any " characters from $1 and $3
  ;
  StrCpy $R0 $1 1 0
  StrCmp $R0 '"' fix1 check2
  fix1:
    StrLen $R0 $1
    IntOp $R0 $R0 - 2
    StrCpy $1 $1 $R0 1
  check2:
    StrCpy $R0 $3 1 0
    StrCmp $R0 '"' fix2 start
  fix2:
    StrLen $R0 $3
    IntOp $R0 $R0 - 2
    StrCpy $3 $3 $R0 1
  start:
  ;
  ; check if last char in $1 is \
  ; if so, delete it
  ;
  StrLen $R0 $1
  IntOp $R0 $R0 - 1
  StrCpy $R2 $1 1 $R0
  StrCmp $R2 "\" 0 findwin
  StrCpy $1 $1 $R0 0
  ;
  findwin:
  FindWindow $3 "" "$3"
  StrCmp $3 0 getwindow runfolder
  getwindow:
    StrCpy $3 $HWNDPARENT
  ;
  runfolder:
  ;
  ; check if we're on NT4, 9x systems
  ;
  Call GetWindowsVersion
  Pop $R0
  StrCmp $R0 "9xNT" 0 newwin
    StrCpy $R0 ""
    GoTo dialogsrun
  newwin:
    StrCpy $R0 "Default directory: $1"
;    MessageBox MB_OK "$3$\n$1"
  dialogsrun:
;    MessageBox MB_OK "$3$\nBrowse for Directory$\n$R0$\n$1$\n"
    ;
    ; version 2.1 and earlier of Dialogs
    ;
    Dialogs::Folder $3 "Browse for Directory" "$R0" $1 ${VAR_2}
    ;
    ; version 2.2 and earlier of Dialogs
    ;
;    Dialogs::Folder "Browse for Directory" "$R0" $1 ${VAR_2}
;    MessageBox MB_OK "$2"
    StrCmp $2 "0" Cancel
    StrCmp $2 "" Cancel Ok
  Cancel:
     StrCpy $2 cancel
  Ok:
    Push $9
    FileOpen $9 '$EXEDIR\folder.txt' w ;Opens a Empty File an fills it
    FileWrite $9 "$2$\r$\n"
    FileClose $9 ;Closes the emtpy file
    GoTo stop
  ;
  usage:
    !insertmacro smMessageBox "i 0" "Usage:$\n$\n    folder dir windowname$\n$\nwhere DIR is the directory where the select folder dialog should open,$\nand WINDOWNAME is the text string in the window titlebar. folder writes$\nyour selection to the file 'folder.txt' in '$EXEDIR'.$\nPlease use quotation marks around DIR and WINDOWNAME so that$\nfolder can easily separate these 2 variables from one another.$\n$\nExample:$\n$\n    folder 'c:\program files' 'Preferences'$\n" "SVAR Folder Dialog" ${MB_OK} "i 103"
  stop:
  Quit
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

Function SplitCommand
   Push $R0
   Push $R1
   Push $R2
   StrCpy $R0 $1 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $1 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $1 1 $R2
      StrCmp $R0 " " loop2
   Exch $R2
FunctionEnd

Function GetWindowsVersion
   Push $R0
   Push $R1
   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
   StrCmp $R0 "" 0 lbl_winnt
   ; we are not NT.
   ReadRegStr $R0 HKLM SOFTWARE\Microsoft\Windows\CurrentVersion VersionNumber

   StrCpy $R1 $R0 1
   StrCmp $R1 '4' 0 lbl_error

   StrCpy $R1 $R0 3

   StrCmp $R1 '4.0' lbl_win32_95
   StrCmp $R1 '4.9' lbl_win32_ME lbl_win32_98

   lbl_win32_95:
     StrCpy $R0 '9xNT'
   Goto lbl_done

   lbl_win32_98:
     StrCpy $R0 '9xNT'
   Goto lbl_done

   lbl_win32_ME:
     StrCpy $R0 'ME'
   Goto lbl_done

   lbl_winnt:

     StrCpy $R1 $R0 1

     StrCmp $R1 '3' lbl_winnt_x
     StrCmp $R1 '4' lbl_winnt_x

     StrCpy $R1 $R0 3

     StrCmp $R1 '5.0' lbl_winnt_2000
     StrCmp $R1 '5.1' lbl_winnt_XP
     StrCmp $R1 '5.2' lbl_winnt_dotNET lbl_error

     lbl_winnt_x:
       StrCpy $R0 '9xNT'
     Goto lbl_done

     lbl_winnt_2000:
       Strcpy $R0 '2000'
     Goto lbl_done

     lbl_winnt_XP:
       Strcpy $R0 'XP'
     Goto lbl_done

     lbl_winnt_dotNET:
       Strcpy $R0 '2003'
     Goto lbl_done

   lbl_error:
     Strcpy $R0 ''
   lbl_done:
   Pop $R1
   Exch $R0
FunctionEnd

