SilentInstall silent

; The name of the NSIS install program you're creating
Name "Browser Launcher"
SetPluginUnload  alwaysoff
!include "${NSISDIR}\Contrib\System\sysfunc.nsh"

; The icon
Icon "konqueror.ico"

; The file that NSIS writes
OutFile "run_browser.exe"

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "run_browser.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "run_browser.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Default Browser Launcher"

Section .onInit
  Call GetParameters
  Pop $R8
  Push $1
  StrCpy $1 $R8
  ;
  ; check for the default http browser
  ;
  Call GetBrowser
  Pop $R0
;  MessageBox MB_OK $R0
  Push $2
  StrCpy $2 $R0
  ;
  StrCmp $1 '' usage end
  usage:
  !insertmacro smMessageBox "i 0" 'Usage:$\n$\n    run_browser URI$\n$\nwhere URI is a web link such as http://www.texlips.net/.' "Browser Launcher" ${MB_OK} "i 103"
  Abort
  end:
SectionEnd

Section "Launch"
  SetPluginUnload manual
  Exec '$2 $1'
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

Function GetBrowser
   Push $R0
   Push $R1
   ReadRegStr $R1 HKCR "http\shell" ""
   StrCmp $R1 '' next browser_check
   next:
      StrCpy $R1 "open"
   browser_check:
   ReadRegStr $R0 HKCR "http\shell\$R1\command" ""
   ;
   ; delete any -nohome
   ;
   Push $R2
   StrLen $R2 $R0
   Push $R3
   IntOp $R2 $R2 - 7
   StrCpy $R3 $R0 7 $R2
   StrCmp $R3 '-nohome' ie_fix ie_done
;   MessageBox MB_OK $R0
   ie_fix:
      IntOp $R2 $R2 - 1
      StrCpy $R0 $R0 $R2 0
;      MessageBox MB_OK $R0
   ie_done:
   Push $R2
   StrLen $R2 $R0
   Push $R3
   IntOp $R2 $R2 - 4
   StrCpy $R3 $R0 4 $R2
   StrCmp $R3 '"%1"' browser_fix browser_done
   browser_fix:
      IntOp $R2 $R2 - 1
      StrCpy $R0 $R0 $R2 0
;      MessageBox MB_OK $R0
   browser_done:
   Exch $R0
FunctionEnd




