SilentInstall silent

; The name of the NSIS install program you're creating
Name "SetFocus"
SetPluginUnload  alwaysoff
!include "${NSISDIR}\Contrib\System\sysfunc.nsh"
!include "setfocus.nsh"
;!define WM_ACTIVATE    0x6
!define WA_ACTIVE      0x1
!define WA_CLICKACTIVE 0x2

; The icon
Icon "setfocus.ico"

; The file that NSIS writes
OutFile "setfocus.exe"

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "setfocus.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "setfocus.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Sets focus on control"

Function .onInit
  Call GetParameters
  Pop $R8
  Push $1
  StrCpy $1 $R8
  ;
  ; check if command line is empty
  ;
  StrCmp $1 '' usage end
  usage:
    !insertmacro smMessageBox "i 0" "Usage:$\n$\n    setfocus windowname id$\n$\nwhere WINDOWNAME is the text string in the window titlebar, and ID$\nis the control with id-number ID that should receive focus. SetFocus$\nlocates all controls with ID=0 and gives them a unique number, where$\nthe new number is 1 for the last control, 2 for the second last, etc.$\n$\nExample:$\n$\n    setfocus Structural VAR - Estimate 2$\n$\ngives focus to the Yes button on the window with the above name." "SetFocus" ${MB_OK} "i 103"
    Abort
  end:
FunctionEnd

Section "Launch"
;  SetPluginUnload manual
  ;
  ; Split command-line into window name and ID-number
  ;
  Call SplitCommand
  Pop $R0
  StrCmp $R0 '-1' stop
  Push $2
  Push $3
  StrCpy $2 $1 $R0 0
  Push $R1
  Push $R2
  StrLen $R2 $1
  IntOp $R0 $R0 + 1
  IntOp $R1 $R2 - $R0
  StrCpy $3 $1 $R1 $R0
  ;
  ; $2 holds the window name
  ; $3 holds the ID number
  ;
  ; now we loop using find-window getdlgitem
  ; until we find no control with id=0
  ;
  Push $4
  FindWindow $4 "" "$2"
  StrCmp $4 '0' stop
  GetDlgItem $4 $4 59648
  Push $5
  StrCpy $5 0
  Push $6
  IntOp $6 $3 + 1
  loopwindow:
    IntOp $5 $5 + 1
    StrCmp $5 $6 exitloop
    Push $0
    GetDlgItem $0 $4 0
    StrCmp $0 '0' exitloop
    !insertmacro ChangeID "$0" "$5"
    GoTo loopwindow
  exitloop:
  ;
  ; we've now changed the IDs such that each
  ; control that initially had ID=0 now has
  ; a unique integer id. Now we send the message
  ; to the control with ID=$3
  ;
  FindWindow $4 "" "$2"
  GetDlgItem $4 $4 59648
  GetDlgItem $4 $4 $3
  StrCmp $4 '0' stop
  SendMessage $4 ${WM_ACTIVATE} "${WA_ACTIVE}" "$4"
  stop:
    SetPluginUnload manual
    System::Free 0
    Abort
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

Function SplitCommand
   Push $R0
   Push $R1
   StrLen $R0 $1
   ;
   ; search for a space character
   ;
   loop:
      IntOp $R0 $R0 - 1
      StrCpy $R1 $1 1 $R0
      StrCmp $R1 " " done
      StrCmp $R0 '-1' done
      GoTo loop
   done:
   ;
   ; we have located the space where commands should be split
   ;
   Exch $R0
FunctionEnd

