SilentInstall silent

; The name of the NSIS install program you're creating
Name "SetIcon"
SetPluginUnload  alwaysoff
!include "${NSISDIR}\Contrib\System\sysfunc.nsh"
!include "seticon.nsh"

; The icon
Icon "seticon.ico"

; The file that NSIS writes
OutFile "seticon.exe"

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "seticon.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "seticon.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Sets Window Icon"

Function .onInit
  Call GetParameters
  Pop $R8
  Push $1
  StrCpy $1 $R8
  ;
  ; check if command line is empty
  ;
  StrCmp $1 'INIT' init
  StrCmp $1 '' usage end
  usage:
    !insertmacro smMessageBox "i 0" "Usage:$\n$\n    seticon windowname iconfile$\n$\nwhere WINDOWNAME is the text string in the window and ICONFILE$\nis the path plus filename of an icon or NULL. If iconfile is NULL, the$\noriginal icon will be hidden from the titlebar. If iconfile contains a space$\ncharacter, you need to use quotation marks around iconfile.$\n$\nExamples:$\n$\n    seticon Structural VAR c:\icons\myicon.ico$\n$\n    seticon Structural VAR - Estimate NULL$\n" "SetIcon" ${MB_OK} "i 103"
  init:
    Abort
  end:
FunctionEnd

Section "Launch"
  Call SplitCommand
  Pop $R0
  StrCmp $R0 '-1' stop
  Push $2
  Push $3
  StrCpy $2 $1 $R0 0
  Push $R1
  Push $R2
  StrLen $R2 $1
  IntOp $R0 $R0 + 1
  IntOp $R1 $R2 - $R0
  StrCpy $3 $1 $R1 $R0
  ;
  ; check for qoutations marks around $3
  ; if found we need to remove them
  ;
  StrLen $R2 $3
  IntOp $R2 $R2 - 1
  StrCpy $R1 $3 1 $R2
  StrCmp $R1 "'" fix2
  StrCmp $R1 '"' fix3 findwind
  fix3:
    IntOp $R2 $R2 - 1
    StrCpy $3 $3 $R2 1
    GoTo findwind
  fix2:
    IntOp $R2 $R2 - 1
    StrCpy $3 $3 $R2 1
  ;
  ; $2 holds the window name
  ; $3 holds the icon path+filename
  ;
  ; Now we look for the window handle
  ;
  
  findwind:
;  MessageBox MB_OK "$2$\n$3"
    FindWindow $1 "" "$2"
    StrCmp $1 0 stop
  ;
  ; $1 hold the handle to the window
  ;
  !insertmacro DisplayIcon "$1" "$3"
  ;
  ; set up a loop which ends seticon when the program
  ; window has been killed
  StrCmp $3 'NULL' stop
  loop:
    Sleep 3600000
    GoTo loop
  stop:
  ;  SetPluginUnload manual
  System::Free 0
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

Function SplitCommand
   Push $R0
   Push $R1
   StrLen $R0 $1
   ;
   ; check if we should search for a space character or a
   ; quotation mark
   ;
   Push $R2
   Push $R3
   IntOp $R0 $R0 - 1
   StrCpy $R2 $1 1 $R0
   StrCpy $R3 ' '
   StrCmp $R2 "'" quote
   StrCmp $R2 '"' next loop
   next:
     StrCpy $R3 '"'
     GoTo loop
   quote:
     StrCpy $R3 "'"
   ; search for a space character
   ;
   loop:
      IntOp $R0 $R0 - 1
      StrCpy $R1 $1 1 $R0
      StrCmp $R1 '$R3' done
      StrCmp $R0 '-1' done
      GoTo loop
   done:
   StrCmp $R3 ' ' retfunc
   StrCmp $R0 '-1' retfunc
   IntOp $R0 $R0 - 1
   ;
   ; we have located the space where commands should be split
   ;
   retfunc:
   Exch $R0
FunctionEnd

