SilentInstall silent

; The name of the NSIS install program you're creating
Name "Silent Application Launcher"
SetPluginUnload  alwaysoff
!include "${NSISDIR}\Contrib\System\sysfunc.nsh"
!ifndef SW_SHOWMAXIMIZED
  !define SW_SHOWMAXIMIZED   3
!endif
!ifndef sysShowWindow
  !define sysShowWindow       "user32::ShowWindow(i, i) i"
!endif

; The icon
Icon "show_maximized.ico"

; The file that NSIS writes
OutFile "show_maximized.exe"

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "show_maximized.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "show_maximized.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Maximize window"

Function .onInit
  Call GetParameters
  Pop $R8
  Push $1
  StrCpy $1 $R8
  ;
  ; check if command line is empty
  ;
  StrCmp $1 '' usage end
  usage:
    !insertmacro smMessageBox "i 0" "Usage:$\n$\n    show_maximized window_title$\n$\nwhere WINDOW_TITLE is the title of the window to be maximized." "Maximize Window" ${MB_OK} "i 103"
    Abort
  end:
FunctionEnd

Section "Launch"
  ;
  ; find the handle to the window with title $1
  ;
  Push $2
  StrCpy $2 1
  Push $R0
  findwin:
  StrCmp $2 101 stop
  FindWindow $R0 "" "$1"
  StrCmp $R0 0 0 mymax
  ;
  Sleep 100
  IntOp $2 $2 + 1
  GoTo findwin
  ;
;  Sleep 250
;  FindWindow $R0 "" "$1"
;  StrCmp $R0 0 stop
  ;
  mymax:
  Push $R1
  System::Call '${sysShowWindow} ($R0, ${SW_SHOWMAXIMIZED}) .r1'
  ;
  ; do something so we can properly unload the system plugin
  ;
  FileOpen $R1 '$TEMP\junk.txt' w ;Opens a Empty File an fills it
  FileWrite $R1 "$R0$\r$\n"
  FileClose $R1 ;Closes the emtpy file
  ;
  ; now we delete the file
  ;
  Delete $TEMP\junk.txt
  ;
  ;
  stop:
    SetPluginUnload manual
    System::Free 0
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

