SilentInstall silent

; The name of the NSIS install program you're creating
Name "Structural VAR"
SetPluginUnload  alwaysoff
!include "${NSISDIR}\Contrib\System\sysfunc.nsh"

; The icon
Icon "var_icon.ico"

; The file that NSIS writes
OutFile "svar.exe"


LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "svar.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "svar.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Structural VAR Launcher"

!macro CallFindFiles DIR FILE CBFUNC
Push "${DIR}"
Push "${FILE}"
Push $0
GetFunctionAddress $0 "${CBFUNC}"
Exch $0
Call FindFiles
!macroend

Function .onInit
  System::Call 'kernel32::CreateMutexA(i 0, i 0, t "SVAR") i .r1 ?e'
  pop $0
  StrCmp $0 0 done
  StrCmp $0 183 0 aborting
    !insertmacro smMessageBox "i 0" "Structural VAR is already running." "Structural VAR" ${MB_OK} "i 103"
    aborting:
    SetPluginUnload manual
    System::Free 0
    Sleep 10
    Call CleanUp
    Abort
  done:
  Call CleanUp
FunctionEnd

Section "Launch"
  SetPluginUnload manual
  System::Free 0
  ; Change this exe file to the name of the exe you created
  Call GetParameters
  Pop $R8
  StrCmp $R8 '' findexe
  ;
  ; we need to replace " characters with ' characters
  ; in $R8
  ;
  Push $R8 ; variable to do replacment in
  Push '"' ; string to replace
  Push "'" ; replacement
  Call StrRep
  Pop $R8 ;result
;  StrCpy $R8 $R0
;  MessageBox MB_OK "$R8"
  findexe:
  Call GetExeFile
  Pop $R0
  Push $R0
  Call GetParent
  Pop $R0
  Push $1
  Push $2
  StrCmp $R0 "" fixr0 fix1
  fixr0:
    StrCpy $R0 $EXEDIR
  ;
  ; check if there's a space in $R0
  ;
  fix1:
    StrCpy $1 $R0
    Call SplitCommand
    Pop $3
    StrCmp $3 '-1' nospace space
  space:
    StrCpy $1 "--dir='$R0' $R8"
    StrCpy $2 '"$R0\var.exe"'
    GoTo version
  nospace:
    StrCpy $1 "--dir=$R0 $R8"
    StrCpy $2 $R0\var.exe
  version:
  ;
;  MessageBox MB_OK $2
;  Call GetWindowsVersion
;  Pop $R0
  ;
  ; if NT type system
  ;
;  MessageBox MB_OK $R0
;  MessageBox MB_OK "$2 $1"
;  StrCmp $R0 'DOS' dos
;     nsExec::Exec "cmd /C $2 $1"
     nsExec::Exec '$2 $1'
;  Goto stop
;  dos:
;     nsExec::Exec "command.com /C $2 $1"
;  stop:
;  MessageBox MB_OK "$PLUGINSDIR"
  ;
  ; try to locate the ns*.tmp file if it hasn't already been unloaded
  ;
  Call GetWindowsVersion
  Pop $R0
  StrCmp $R0 'DOS' cleanupfiles
  FindFirst $R0 $R1 "$PLUGINSDIR\ns*.tmp"
  FindClose $R0
  StrCmp $R1 '' cleanupfiles
  ;
  ; the ns*.tmp file may still be running. now we force a shut down
  ;
  KillProcDLL::killproc "$R1"
  Delete /REBOOTOK "$PLUGINSDIR\$R1"
  ;
  cleanupfiles:
  Call CleanUp
  Quit
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

Function GetExeFile
   Push $R0
   Push $R1
   Push $R2
   Push $R3
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      StrCpy $R0 $CMDLINE 1 $R2
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   IntOp $R2 $R2 - 2
   StrCpy $R0 $CMDLINE $R2
   StrCpy $R3 $R0 1
   StrCmp $R3 '"' next exit
   next:
      IntOp $R3 $R2 - 1
      StrCpy $R0 $R0 $R3 1
   exit:
   Pop $R2
   Pop $R1
   Exch $R0
FunctionEnd

Function GetParent
   Exch $R0 ; old $R0 is on top of stack
   Push $R1
   Push $R2
   StrCpy $R1 -1
   loop:
     StrCpy $R2 $R0 1 $R1
     StrCmp $R2 "" exit
     StrCmp $R2 "\" exit
     IntOp $R1 $R1 - 1
   Goto loop
   exit:
     StrCpy $R0 $R0 $R1
     Pop $R2
     Pop $R1
     Exch $R0 ; put $R0 on top of stack, restore $R0 to original value
 FunctionEnd


; GetWindowsVersion
 ;
 ; Based on Yazno's function, http://yazno.tripod.com/powerpimpit/
 ; Returns on top of stack
 ;
 ; Windows Version (95, 98, ME, NT x.x, 2000, XP, .NET Server)
 ; or
 ; '' (Unknown Windows Version)
 ;
 ; Usage:
 ;   Call GetWindowsVersion
 ;   Pop $R0
 ;   ; at this point $R0 is "NT 4.0" or whatnot

Function GetWindowsVersion
   Push $R0
   Push $R1
   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
   StrCmp $R0 "" 0 lbl_winnt
   ; we are not NT.
   ReadRegStr $R0 HKLM SOFTWARE\Microsoft\Windows\CurrentVersion VersionNumber

   StrCpy $R1 $R0 1
   StrCmp $R1 '4' 0 lbl_error

   StrCpy $R1 $R0 3

   StrCmp $R1 '4.0' lbl_win32_95
   StrCmp $R1 '4.9' lbl_win32_ME lbl_win32_98

   lbl_win32_95:
     StrCpy $R0 'DOS'
   Goto lbl_done

   lbl_win32_98:
     StrCpy $R0 'DOS'
   Goto lbl_done

   lbl_win32_ME:
     StrCpy $R0 'DOS'
   Goto lbl_done

   lbl_winnt:

     StrCpy $R1 $R0 1

     StrCmp $R1 '3' lbl_winnt_x
     StrCmp $R1 '4' lbl_winnt_x

     StrCpy $R1 $R0 3

     StrCmp $R1 '5.0' lbl_winnt_2000
     StrCmp $R1 '5.1' lbl_winnt_XP
     StrCmp $R1 '5.2' lbl_winnt_dotNET lbl_error

     lbl_winnt_x:
       StrCpy $R0 "NT $R0" 6
     Goto lbl_done

     lbl_winnt_2000:
       Strcpy $R0 '2000'
     Goto lbl_done

     lbl_winnt_XP:
       Strcpy $R0 'XP'
     Goto lbl_done

     lbl_winnt_dotNET:
       Strcpy $R0 '.NET Server'
     Goto lbl_done

   lbl_error:
     Strcpy $R0 ''
   lbl_done:
   Pop $R1
   Exch $R0
FunctionEnd

Function FindFiles
   Exch $R5  # callback function
   Exch
   Exch $R4  # filename
   Exch 2
   Exch $R0  # directory
   Push $R1
   Push $R2
   Push $R3
   Push $R6
   Push $R0  # first dir to search
   StrCpy $R3 1
   nextDir:
      Pop $R0
      IntOp $R3 $R3 - 1
      ClearErrors
      FindFirst $R1 $R2 "$R0\*.*"
      nextFile:
         StrCmp $R2 "." gotoNextFile
         StrCmp $R2 ".." gotoNextFile
         StrCmp $R2 $R4 0 isDir
            Push "$R0\$R2"
            Call $R5
            Pop $R6
            StrCmp $R6 "stop" 0 isDir
               loop:
               StrCmp $R3 0 done
               Pop $R0
               IntOp $R3 $R3 - 1
               GoTo loop
        isDir:
           IfFileExists "$R0\$R2\*.*" 0 gotoNextFile
              IntOp $R3 $R3 + 1
              Push "$R0\$R2"
   gotoNextFile:
      FindNext $R1 $R2
      IfErrors 0 nextFile
   done:
      FindClose $R1
      StrCmp $R3 0 0 nextDir
      
   Pop $R6
   Pop $R3
   Pop $R2
   Pop $R1
   Pop $R0
   Pop $R5
   Pop $R4
FunctionEnd

Function FindnsExec
   Pop $0
   GetDLLVersion $0 $1 $3
   IntOp $2 $1 & 0x0000FFFF
   IntOp $1 $1 / 0x00010000
   IntOp $4 $3 & 0x0000FFFF
   IntOp $3 $3 / 0x00010000
   StrCpy $9 $0
   Push "stop"
FunctionEnd

Function CleanUp
  ;
  ; clean up after previous launches
  ;
  Push $8
  ;
  ; search for nsExec.dll files in tempdir
  ;
  nsexec:
  !insertmacro CallFindFiles $TEMP nsExec.dll FindnsExec
  ;
  StrCmp $9 '' systemdll
  StrCmp $9 $8 systemdll
  Delete /REBOOTOK $9
  ;
  ; need to determine the directory
  Push $R0
  Push $R1
  StrLen $R1 $9
  IntOp $R1 $R1 - 11
  StrCpy $R0 $9 $R1 0
  RmDir /REBOOTOK $R0
  Push $8
  StrCpy $8 $9
  GoTo nsexec
  ;
  ; search for system.dll files in tempdir
  ;
  ;
  systemdll:
  !insertmacro CallFindFiles $TEMP System.dll FindnsExec
  StrCmp $9 '' dialerdll
  StrCmp $9 $8 dialerdll
  Delete /REBOOTOK $9
  ;
  ; need to determine the directory
  Push $R0
  Push $R1
  StrLen $R1 $9
  IntOp $R1 $R1 - 11
  StrCpy $R0 $9 $R1 0
  RmDir /REBOOTOK $R0
  Push $8
  StrCpy $8 $9
  GoTo systemdll
  ;
  ; search for dialer.dll files in tempdir
  ;
  dialerdll:
  !insertmacro CallFindFiles $TEMP Dialer.dll FindnsExec
  StrCmp $9 '' nsisdldll
  StrCmp $9 $8 nsisdldll
  Delete /REBOOTOK $9
  ;
  ; need to determine the directory
  Push $R0
  Push $R1
  StrLen $R1 $9
  IntOp $R1 $R1 - 11
  StrCpy $R0 $9 $R1 0
  RmDir /REBOOTOK $R0
  Push $8
  StrCpy $8 $9
  GoTo dialerdll
  ;
  ; search for nsisdl.dll in tempdir
  ;
  nsisdldll:
  !insertmacro CallFindFiles $TEMP nsisdl.dll FindnsExec
  StrCmp $9 '' end
  StrCmp $9 $8 end
  Delete /REBOOTOK $9
  ;
  ; need to determine the directory
  Push $R0
  Push $R1
  StrLen $R1 $9
  IntOp $R1 $R1 - 11
  StrCpy $R0 $9 $R1 0
  RmDir /REBOOTOK $R0
  Push $8
  StrCpy $8 $9
  GoTo nsisdldll
  end:
FunctionEnd

Function SplitCommand
   Push $3
   Push $R1
   StrLen $3 $1
   ;
   ; search for a space character
   ;
   loop:
      IntOp $3 $3 - 1
      StrCpy $R1 $1 1 $3
      StrCmp $R1 " " done
      StrCmp $3 '-1' done
      GoTo loop
   done:
   ;
   ; we have located the space where commands should be split
   ;
   Exch $3
FunctionEnd

Function StrRep
  Exch $R4 ; $R4 = Replacement String
  Exch
  Exch $R3 ; $R3 = String to replace (needle)
  Exch 2
  Exch $R1 ; $R1 = String to do replacement in (haystack)
  Push $R2 ; Replaced haystack
  Push $R5 ; Len (needle)
  Push $R6 ; len (haystack)
  Push $R7 ; Scratch reg
  StrCpy $R2 ""
  StrLen $R5 $R3
  StrLen $R6 $R1
loop:
  StrCpy $R7 $R1 $R5
  StrCmp $R7 $R3 found
  StrCpy $R7 $R1 1 ; - optimization can be removed if U know len needle=1
  StrCpy $R2 "$R2$R7"
  StrCpy $R1 $R1 $R6 1
  StrCmp $R1 "" done loop
found:
  StrCpy $R2 "$R2$R4"
  StrCpy $R1 $R1 $R6 $R5
  StrCmp $R1 "" done loop
done:
  StrCpy $R3 $R2
  Pop $R7
  Pop $R6
  Pop $R5
  Pop $R2
  Pop $R1
  Pop $R4
  Exch $R3
FunctionEnd

