SilentInstall silent

; The name of the NSIS install program you're creating
Name "SVAR Version Checker"
SetPluginUnload  alwaysoff
!include "${NSISDIR}\Contrib\System\sysfunc.nsh"

; The icon
Icon "version.ico"

; The file that NSIS writes
OutFile "version.exe"

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
;--------------------------------
;Version Information

  VIProductVersion "0.45.2.0"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "Structural VAR"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "Structural VAR homepage: http://www.texlips.net/svar/"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "Copyright  2001-2008 Anders Warne"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "OriginalFilename" "version.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "InternalName" "version.exe"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductVersion" "0.45"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.45.2.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Downloads silently from the internet"

Section "Launch"
  Call GetParameters
  Pop $R8
  Push $1
  StrCpy $1 $R8
  ;
  ; check if command line is empty
  ;
  StrCmp $1 '' usage
  Call ConnectInternet
  Pop $R0
  ;
  StrCmp $R0 "offline" stop
  Call SplitCommand1
  Pop $R7
  Push $2
  StrCpy $2 $R7
  StrCmp $2 "" usage
  Call SplitCommand2
  Pop $R6
  Push $3
  StrCpy $3 $R6
  Push $4
  StrCpy $4 $3 7 0
  StrCmp $4 "http://" download
  Push $4
  StrCpy $4 $3 6 0
  StrCmp $4 "ftp://" download
  FileOpen $9 version.log w ;Opens a Empty File an fills it
  FileWrite $9 "bad command$\r$\n$3 $2$\r$\n"
  FileClose $9 ;Closes the emtpy file
  ;
  usage:
    !insertmacro smMessageBox "i 0" "Usage:$\n$\n    version getfile savefile$\n$\nwhere getfile is the URL to the file to download and savefile is the path+filename$\nwhere the file should be stored. version runs silently but logs the return value$\nof the download attempt in 'version.log'.$\n$\nExample:$\n$\n    version http://www.mydomain.com/download/file.zip c:\download\file.zip$\n" "SVAR Version Checker" ${MB_OK} "i 103"
  GoTo stop
  download:
    SetPluginUnload manual
    ;
    ; we need to remove any " characters from $2
    ;
    Push $2 ; variable to do replacment in
    Push '"' ; string to replace
    Push "" ; replacement
    Call StrRep
    Pop $2 ;result
    NSISdl::download /TIMEOUT=30000 "$3" "$2"
    Pop $R0 ;Get the return value
    FileOpen $9 version.log w ;Opens a Empty File an fills it
    FileWrite $9 "$R0$\r$\n"
    FileClose $9 ;Closes the emtpy file
  stop:
SectionEnd

; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.

Function GetParameters
   Push $R0
   Push $R1
   Push $R2
   Push $R8
   StrCpy $R0 $CMDLINE 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $CMDLINE "" $R2
   StrCpy $R8 $CMDLINE "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R8
FunctionEnd

Function ConnectInternet
  Push $R0
    ClearErrors
    Dialer::AttemptConnect
    IfErrors noie3
    Pop $R0
    StrCmp $R0 "online" connected
      !insertmacro smMessageBox "i 0" "Cannot connect to the internet." "SVAR Version Checker" ${MB_OK} "i 103"
      FileOpen $9 version.log w ;Opens a Empty File an fills it
      FileWrite $9 "offline$\r$\n"
      FileClose $9 ;Closes the emtpy file
      Quit ;Remove to make error not fatal
    noie3:
    ; IE3 not installed
    !insertmacro smMessageBox "i 0" "Please connect to the internet now." "SVAR Version Checker" ${MB_OK} "i 103"
    FileOpen $9 version.log w ;Opens a Empty File an fills it
    FileWrite $9 "offline$\r$\n"
    FileClose $9 ;Closes the emtpy file
    connected:
  Exch $R0
FunctionEnd

Function SplitCommand1
;   Call GetParameters
;   Pop $R8
;   MessageBox MB_OK "$1"
   Push $R0
   Push $R1
   Push $R2
   Push $R7
   StrCpy $R0 $1 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   StrCmp $R0 '"' loop
      StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
   loop:
      StrCpy $R0 $1 1 $R2
      StrCmp $R0 $R1 loop2
      StrCmp $R0 "" loop2
      IntOp $R2 $R2 + 1
      Goto loop
   loop2:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $1 1 $R2
      StrCmp $R0 " " loop2
   StrCpy $R0 $1 "" $R2
   StrCpy $R7 $1 "" $R2
   Pop $R2
   Pop $R1
   Pop $R0
   Exch $R7
FunctionEnd

Function SplitCommand2
   Push $R0
   Push $R1
   Push $R2
   Push $R6
   StrCpy $R0 $1 1
   StrCpy $R1 '"'
   StrCpy $R2 1
   loop:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $1 1 $R2
      StrCmp $R0 " " done loop
   done:
   StrCpy $R6 $1 $R2 0
   Exch $R6
FunctionEnd

Function StrRep
  Exch $R4 ; $R4 = Replacement String
  Exch
  Exch $R3 ; $R3 = String to replace (needle)
  Exch 2
  Exch $R1 ; $R1 = String to do replacement in (haystack)
  Push $R2 ; Replaced haystack
  Push $R5 ; Len (needle)
  Push $R6 ; len (haystack)
  Push $R7 ; Scratch reg
  StrCpy $R2 ""
  StrLen $R5 $R3
  StrLen $R6 $R1
loop:
  StrCpy $R7 $R1 $R5
  StrCmp $R7 $R3 found
  StrCpy $R7 $R1 1 ; - optimization can be removed if U know len needle=1
  StrCpy $R2 "$R2$R7"
  StrCpy $R1 $R1 $R6 1
  StrCmp $R1 "" done loop
found:
  StrCpy $R2 "$R2$R4"
  StrCpy $R1 $R1 $R6 $R5
  StrCmp $R1 "" done loop
done:
  StrCpy $R3 $R2
  Pop $R7
  Pop $R6
  Pop $R5
  Pop $R2
  Pop $R1
  Pop $R4
  Exch $R3
FunctionEnd

